Index: trunk/debian/VBox.sh
===================================================================
--- trunk/debian/VBox.sh	(revision 5451)
+++ trunk/debian/VBox.sh	(revision 5452)
@@ -34,5 +34,5 @@
 WARNING: The character device /dev/vboxdrv does not exist. Try
 
-           sudo /etc/init.d/virtualbox restart
+           sudo /etc/init.d/vboxdrv restart
 
          and if that is not successful, try to re-install the package.
@@ -90,14 +90,14 @@
 case "$APP" in
   VirtualBox)
-    exec "/usr/lib/virtualbox/VirtualBox" "$@"
+    exec "/usr/lib/virtualbox-ose/VirtualBox" "$@"
   ;;
   VBoxManage)
-    exec "/usr/lib/virtualbox/VBoxManage" "$@"
+    exec "/usr/lib/virtualbox-ose/VBoxManage" "$@"
   ;;
   VBoxSDL)
-    exec "/usr/lib/virtualbox/VBoxSDL" "$@"
+    exec "/usr/lib/virtualbox-ose/VBoxSDL" "$@"
   ;;
   VBoxVRDP)
-    exec "/usr/lib/virtualbox/VBoxVRDP" "$@"
+    exec "/usr/lib/virtualbox-ose/VBoxVRDP" "$@"
   ;;
   *)
Index: trunk/debian/changelog
===================================================================
--- trunk/debian/changelog	(revision 5451)
+++ trunk/debian/changelog	(revision 5452)
@@ -1,2 +1,8 @@
+virtualbox-ose (1.5.0+svn+OSE-1) unstable; urgency=low
+
+  * rebuild Debian packet
+
+ -- innotek GmbH <info@virtualbox.org>  Thu, 23 Oct 2007 21:54:00 +0200
+
 virtualbox-ose (1.5.0+svn+OSE-1) unstable; urgency=low
 
Index: trunk/debian/lintian-override
===================================================================
--- trunk/debian/lintian-override	(revision 5451)
+++ trunk/debian/lintian-override	(revision 5452)
@@ -1,30 +1,30 @@
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxRT.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxDD.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxDD2.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxDDU.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxKeyboard.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxVMM.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxXML.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxREM.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxXPCOM.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxSharedFolders.so
-virtualbox: shlib-with-non-pic-code usr/lib/VBoxSharedClipboard.so
-virtualbox: shlib-with-non-pic-code usr/lib/virtualbox/components/VBoxSVCM.so
-virtualbox: shlib-with-non-pic-code usr/lib/virtualbox/components/VBoxC.so
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VBoxDDGC.gc
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VBoxDD2GC.gc
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VBoxDDR0.r0
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VBoxDD2R0.r0
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VMMGC.gc
-virtualbox: unstripped-binary-or-object usr/lib/virtualbox/VMMR0.r0
-virtualbox: no-shlibs-control-file usr/lib/VBoxRT.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxDD.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxDD2.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxDDU.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxKeyboard.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxVMM.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxXML.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxREM.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxXPCOM.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxSharedFolders.so
-virtualbox: no-shlibs-control-file usr/lib/VBoxSharedClipboard.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxRT.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxDD.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxDD2.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxDDU.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxKeyboard.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxVMM.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxXML.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxREM.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxXPCOM.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxSharedFolders.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/VBoxSharedClipboard.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/virtualbox-ose/components/VBoxSVCM.so
+virtualbox-ose: shlib-with-non-pic-code usr/lib/virtualbox-ose/components/VBoxC.so
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VBoxDDGC.gc
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VBoxDD2GC.gc
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VBoxDDR0.r0
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VBoxDD2R0.r0
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VMMGC.gc
+virtualbox-ose: unstripped-binary-or-object usr/lib/virtualbox-ose/VMMR0.r0
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxRT.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxDD.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxDD2.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxDDU.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxKeyboard.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxVMM.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxXML.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxREM.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxXPCOM.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxSharedFolders.so
+virtualbox-ose: no-shlibs-control-file usr/lib/VBoxSharedClipboard.so
Index: trunk/debian/postinst
===================================================================
--- trunk/debian/postinst	(revision 5451)
+++ trunk/debian/postinst	(revision 5452)
@@ -36,10 +36,10 @@
 
 # create users groups
-db_input high virtualbox/group-vboxusers || true
+db_input high virtualbox-ose/group-vboxusers || true
 db_go || true
 groupadd -f vboxusers
 
 if [ ! -f /lib/modules/`uname -r`/misc/vboxdrv.ko ]; then
-  db_get virtualbox/module-compilation-allowed
+  db_get virtualbox-ose/module-compilation-allowed
   if [ "$RET" = "false" ]; then
     cat << EOF
@@ -48,7 +48,7 @@
 EOF
   else
-    db_input critical virtualbox/module-compilation-allowed || true
+    db_input critical virtualbox-ose/module-compilation-allowed || true
     db_go || true
-    db_get virtualbox/module-compilation-allowed
+    db_get virtualbox-ose/module-compilation-allowed
     if [ "$RET" = "true" ]; then
       # Compile module. Don't show a message box here if everything works well.
@@ -56,7 +56,7 @@
 Messages emitted during module compilation will be logged to $LOG.
 EOF
-      if ! /usr/share/virtualbox/src/build_in_tmp install > /var/log/vbox-install.log 2>&1; then
-        db_fset virtualbox/module-compilation-failed seen false
-        db_input critical virtualbox/module-compilation-failed || true
+      if ! /usr/share/virtualbox-ose/src/build_in_tmp install > /var/log/vbox-install.log 2>&1; then
+        db_fset virtualbox-ose/module-compilation-failed seen false
+        db_input critical virtualbox-ose/module-compilation-failed || true
         db_go || true
         touch /etc/vbox/module_not_compiled
Index: trunk/debian/preinst
===================================================================
--- trunk/debian/preinst	(revision 5451)
+++ trunk/debian/preinst	(revision 5452)
@@ -8,5 +8,5 @@
 if find /lib/modules -name vboxdrv\* 2>/dev/null|grep -q vboxdrv; then
   # old modules found
-  db_get virtualbox/delete-old-modules
+  db_get virtualbox-ose/delete-old-modules
   if [ "$RET" = "false" ]; then
     cat << EOF
@@ -18,7 +18,7 @@
 EOF
   else
-    db_input critical virtualbox/delete-old-modules || true
+    db_input critical virtualbox-ose/delete-old-modules || true
     db_go || true
-    db_get virtualbox/delete-old-modules
+    db_get virtualbox-ose/delete-old-modules
     if [ "$RET" = "true" ]; then
       find /lib/modules -name vboxdrv\* 2>/dev/null|xargs rm -f 2>/dev/null
Index: trunk/debian/templates
===================================================================
--- trunk/debian/templates	(revision 5451)
+++ trunk/debian/templates	(revision 5452)
@@ -1,3 +1,3 @@
-Template: virtualbox/group-vboxusers
+Template: virtualbox-ose/group-vboxusers
 Type: note
 Description: Creating group 'vboxusers'
@@ -5,5 +5,5 @@
  permissions to /dev/vboxdrv. Otherwise starting of VMs will not be possible.
 
-Template: virtualbox/module-compilation-failed
+Template: virtualbox-ose/module-compilation-failed
 Type: note
 Description: Compilation of the kernel module FAILED!
@@ -16,5 +16,5 @@
  as root.
 
-Template: virtualbox/module-compilation-allowed
+Template: virtualbox-ose/module-compilation-allowed
 Type: boolean
 Default: true
@@ -27,5 +27,5 @@
  However, in case a suitable kernel module already exists at another place you
  might want to override the default position by setting KDIR=<full_path_to_vboxdrv_module>
- in /etc/default/virtualbox. The compilation can also be done later by executing
+ in /etc/default/virtualbox-ose. The compilation can also be done later by executing
    
    /etc/init.d/vboxdrv setup
@@ -33,5 +33,5 @@
  as root.
 
-Template: virtualbox/delete-old-modules
+Template: virtualbox-ose/delete-old-modules
 Type: boolean
 Default: true
Index: trunk/debian/vboxdrv.init.tmpl
===================================================================
--- trunk/debian/vboxdrv.init.tmpl	(revision 5451)
+++ trunk/debian/vboxdrv.init.tmpl	(revision 5452)
@@ -34,6 +34,6 @@
 NOLSB=%NOLSB%
 
-if [ -r /etc/default/virtualbox ]; then
-  . /etc/default/virtualbox
+if [ -r /etc/default/virtualbox-ose ]; then
+  . /etc/default/virtualbox-ose
 fi
 
@@ -153,5 +153,5 @@
     stop
     log_daemon_msg "Recompiling VirtualBox kernel module" "$MODNAME"
-    if ! /usr/share/virtualbox/src/build_in_tmp install > $LOG 2>&1; then
+    if ! /usr/share/virtualbox-ose/src/build_in_tmp install > $LOG 2>&1; then
       failure "Look at $LOG to find out what went wrong"
     fi